#include <stdio.h>
#include "lexhdr.h"
#define HASHSIZE     (199)

TOKEN *hashtable[HASHSIZE];

void add_hash(TOKEN *);

void setupHT()
{int i;
 TOKEN *p;
 TOKEN tmp;

 p=&tmp;

/*--------------------- "Cleaning" the hash table ---------------*/
 for(i=0;i<HASHSIZE;i++){
   hashtable[i] = NULL;
 }
 /*-------------------- Add entries for keywords ----------------*/
 
 p->type = T_IF;         p->lexeme = "if";     add_hash(p);
 p->type = T_ELSE ;      p->lexeme = "else";   add_hash(p);
 p->type = T_WHILE ;     p->lexeme = "while";  add_hash(p);
 p->type = T_INT ;       p->lexeme = "int";    add_hash(p);
 p->type = T_VOID ;      p->lexeme = "void";   add_hash(p);
 p->type = T_RETURN ;    p->lexeme = "return"; add_hash(p);
 p->type = T_LBRA ;      p->lexeme = "(";      add_hash(p);
 p->type = T_RBRA ;      p->lexeme = ")";      add_hash(p);
 p->type = T_COMMA ;     p->lexeme = ",";      add_hash(p);
 p->type = T_SEMICOLON ; p->lexeme = ";";      add_hash(p);
 p->type = T_EQUAL ;     p->lexeme = "=";      add_hash(p);
 p->type = T_STAR ;      p->lexeme = "*";      add_hash(p);
 p->type = T_BARBAR ;    p->lexeme = "||";     add_hash(p);
 p->type = T_ANDAND ;    p->lexeme = "&&";     add_hash(p);


}


int hashify(char *lexeme)   /*----- Returns an index number -----*/
{ int hash=1;
  char *p = lexeme;
 
  while(*p)
      hash*= *p++;
  return (hash % HASHSIZE);  

}


void add_hash(TOKEN *token)
{ 
  TOKEN **p;   /* Pointer to  hashtable[] */
  int pos;   
  int i=0;
  pos = hashify(token->lexeme);

  p  = &hashtable[pos];    /* where we want to write */ 
  while(*p)                /* Find the end, or a match */
    {
     if(!strcmp((token->lexeme),((*p)->lexeme)))
       {
	 return;          /* We found a match */
       };
     p=&((*p)->next);      /* Look at next    */
    };
  
  /* *p points to field "next" of the last element */
  /* Now write to the memory the new hash-entry */

   *p = (TOKEN *) calloc(1,sizeof(TOKEN));
   /* Should add error checing here, but... */
  (*p)->type = token->type;
  (*p)->value = token->value;
  (*p)->lexeme = (char *) strdup(token->lexeme);
  (*p)->next = NULL;  
}  























