#include <stdio.h>
#include "lexhdr.h"


//TOKEN *yylval;

char *type2string(int tok)
{
    switch (tok) {
    case T_VARIABLE:
      return "variable";
    case T_INTEGER:
      return "integer";
    case T_STRING:
      return "string";
    case T_IF:
      return "IF";
    case T_ELSE:
      return "ELSE";
    case T_WHILE:
      return "WHILE";
    case T_INT:
      return "INT";
    case T_VOID:
      return "VOID";
    case T_RETURN:
      return "RETURN";
    case T_LBRA:
      return "LBRA";
    case T_RBRA:
      return "RBRA";
    case T_KET:
      return "KET";
    case T_COMMA:
      return "COMMA";
    case T_SEMICOLON:
      return "SEMICOLON";
    case T_EQUAL:
      return "EQUAL";
    case T_STAR:
      return "STAR";
    case T_SLASH:
      return "SLASH";
    case T_BARBAR:
      return "||";
    case T_ANDAND:
      return "&&";
    case T_UNKNOWN:
      return "UNKNOWN";
    }
}



int main(void)
{
    int type;
    yyinit();		/* Initialise anything needed */
    for (;;) {
      type = yylex();
      printf("Type %s:\t", type2string(type));
      switch (type) {
      case T_STRING:
      case T_UNKNOWN:	
      case T_VARIABLE:
        printf("Lexeme=%s\n", yylval->lexeme);
	break;
      case T_INTEGER:
	printf("Value=%d\n", yylval->value);
	break;
      case T_IF:
      case T_ELSE:
      case T_WHILE:
      case T_INT:
      case T_VOID:
      case T_RETURN:
      case T_LBRA:
      case T_RBRA:
      case T_KET:
      case T_COMMA:
      case T_SEMICOLON:
      case T_EQUAL:
      case T_STAR:
      case T_SLASH:
      case T_BARBAR:
      case T_ANDAND:
	printf("\n");
	break;
      }

    }
}

int yywrap(void)
{
    printf("THAT'S ALL, FOLKS\n");
    exit(0);
}





